2423d7c3ef34b936eb01b63f79bbe0ffedf000c8
1#!/bin/sh
2#
3# git-submodule.sh: add, init, update or list git submodules
4#
5# Copyright (c) 2007 Lars Hjemli
6
7dashless=$(basename "$0" | sed -e 's/-/ /')
8USAGE="[--quiet] add [-b <branch>] [-f|--force] [--name <name>] [--reference <repository>] [--] <repository> [<path>]
9 or: $dashless [--quiet] status [--cached] [--recursive] [--] [<path>...]
10 or: $dashless [--quiet] init [--] [<path>...]
11 or: $dashless [--quiet] deinit [-f|--force] [--] <path>...
12 or: $dashless [--quiet] update [--init] [--remote] [-N|--no-fetch] [-f|--force] [--checkout|--merge|--rebase] [--reference <repository>] [--recursive] [--] [<path>...]
13 or: $dashless [--quiet] summary [--cached|--files] [--summary-limit <n>] [commit] [--] [<path>...]
14 or: $dashless [--quiet] foreach [--recursive] <command>
15 or: $dashless [--quiet] sync [--recursive] [--] [<path>...]"
16OPTIONS_SPEC=
17SUBDIRECTORY_OK=Yes
18. git-sh-setup
19. git-sh-i18n
20. git-parse-remote
21require_work_tree
22wt_prefix=$(git rev-parse --show-prefix)
23cd_to_toplevel
24
25# Restrict ourselves to a vanilla subset of protocols; the URLs
26# we get are under control of a remote repository, and we do not
27# want them kicking off arbitrary git-remote-* programs.
28#
29# If the user has already specified a set of allowed protocols,
30# we assume they know what they're doing and use that instead.
31: ${GIT_ALLOW_PROTOCOL=file:git:http:https:ssh}
32export GIT_ALLOW_PROTOCOL
33
34command=
35branch=
36force=
37reference=
38cached=
39recursive=
40init=
41files=
42remote=
43nofetch=
44update=
45prefix=
46custom_name=
47depth=
48
49# Resolve a path to be relative to another path. This is intended for
50# converting submodule paths when git-submodule is run in a subdirectory
51# and only handles paths where the directory separator is '/'.
52#
53# The output is the first argument as a path relative to the second argument,
54# which defaults to $wt_prefix if it is omitted.
55relative_path ()
56{
57 local target curdir result
58 target=$1
59 curdir=${2-$wt_prefix}
60 curdir=${curdir%/}
61 result=
62
63 while test -n "$curdir"
64 do
65 case "$target" in
66 "$curdir/"*)
67 target=${target#"$curdir"/}
68 break
69 ;;
70 esac
71
72 result="${result}../"
73 if test "$curdir" = "${curdir%/*}"
74 then
75 curdir=
76 else
77 curdir="${curdir%/*}"
78 fi
79 done
80
81 echo "$result$target"
82}
83
84die_if_unmatched ()
85{
86 if test "$1" = "#unmatched"
87 then
88 exit 1
89 fi
90}
91
92#
93# Print a submodule configuration setting
94#
95# $1 = submodule name
96# $2 = option name
97# $3 = default value
98#
99# Checks in the usual git-config places first (for overrides),
100# otherwise it falls back on .gitmodules. This allows you to
101# distribute project-wide defaults in .gitmodules, while still
102# customizing individual repositories if necessary. If the option is
103# not in .gitmodules either, print a default value.
104#
105get_submodule_config () {
106 name="$1"
107 option="$2"
108 default="$3"
109 value=$(git config submodule."$name"."$option")
110 if test -z "$value"
111 then
112 value=$(git config -f .gitmodules submodule."$name"."$option")
113 fi
114 printf '%s' "${value:-$default}"
115}
116
117isnumber()
118{
119 n=$(($1 + 0)) 2>/dev/null && test "$n" = "$1"
120}
121
122#
123# Add a new submodule to the working tree, .gitmodules and the index
124#
125# $@ = repo path
126#
127# optional branch is stored in global branch variable
128#
129cmd_add()
130{
131 # parse $args after "submodule ... add".
132 reference_path=
133 while test $# -ne 0
134 do
135 case "$1" in
136 -b | --branch)
137 case "$2" in '') usage ;; esac
138 branch=$2
139 shift
140 ;;
141 -f | --force)
142 force=$1
143 ;;
144 -q|--quiet)
145 GIT_QUIET=1
146 ;;
147 --reference)
148 case "$2" in '') usage ;; esac
149 reference_path=$2
150 shift
151 ;;
152 --reference=*)
153 reference_path="${1#--reference=}"
154 ;;
155 --name)
156 case "$2" in '') usage ;; esac
157 custom_name=$2
158 shift
159 ;;
160 --depth)
161 case "$2" in '') usage ;; esac
162 depth="--depth=$2"
163 shift
164 ;;
165 --depth=*)
166 depth=$1
167 ;;
168 --)
169 shift
170 break
171 ;;
172 -*)
173 usage
174 ;;
175 *)
176 break
177 ;;
178 esac
179 shift
180 done
181
182 if test -n "$reference_path"
183 then
184 is_absolute_path "$reference_path" ||
185 reference_path="$wt_prefix$reference_path"
186
187 reference="--reference=$reference_path"
188 fi
189
190 repo=$1
191 sm_path=$2
192
193 if test -z "$sm_path"; then
194 sm_path=$(printf '%s\n' "$repo" |
195 sed -e 's|/$||' -e 's|:*/*\.git$||' -e 's|.*[/:]||g')
196 fi
197
198 if test -z "$repo" || test -z "$sm_path"; then
199 usage
200 fi
201
202 is_absolute_path "$sm_path" || sm_path="$wt_prefix$sm_path"
203
204 # assure repo is absolute or relative to parent
205 case "$repo" in
206 ./*|../*)
207 test -z "$wt_prefix" ||
208 die "$(gettext "Relative path can only be used from the toplevel of the working tree")"
209
210 # dereference source url relative to parent's url
211 realrepo=$(git submodule--helper resolve-relative-url "$repo") || exit
212 ;;
213 *:*|/*)
214 # absolute url
215 realrepo=$repo
216 ;;
217 *)
218 die "$(eval_gettext "repo URL: '\$repo' must be absolute or begin with ./|../")"
219 ;;
220 esac
221
222 # normalize path:
223 # multiple //; leading ./; /./; /../; trailing /
224 sm_path=$(printf '%s/\n' "$sm_path" |
225 sed -e '
226 s|//*|/|g
227 s|^\(\./\)*||
228 s|/\(\./\)*|/|g
229 :start
230 s|\([^/]*\)/\.\./||
231 tstart
232 s|/*$||
233 ')
234 git ls-files --error-unmatch "$sm_path" > /dev/null 2>&1 &&
235 die "$(eval_gettext "'\$sm_path' already exists in the index")"
236
237 if test -z "$force" && ! git add --dry-run --ignore-missing "$sm_path" > /dev/null 2>&1
238 then
239 eval_gettextln "The following path is ignored by one of your .gitignore files:
240\$sm_path
241Use -f if you really want to add it." >&2
242 exit 1
243 fi
244
245 if test -n "$custom_name"
246 then
247 sm_name="$custom_name"
248 else
249 sm_name="$sm_path"
250 fi
251
252 # perhaps the path exists and is already a git repo, else clone it
253 if test -e "$sm_path"
254 then
255 if test -d "$sm_path"/.git || test -f "$sm_path"/.git
256 then
257 eval_gettextln "Adding existing repo at '\$sm_path' to the index"
258 else
259 die "$(eval_gettext "'\$sm_path' already exists and is not a valid git repo")"
260 fi
261
262 else
263 if test -d ".git/modules/$sm_name"
264 then
265 if test -z "$force"
266 then
267 echo >&2 "$(eval_gettext "A git directory for '\$sm_name' is found locally with remote(s):")"
268 GIT_DIR=".git/modules/$sm_name" GIT_WORK_TREE=. git remote -v | grep '(fetch)' | sed -e s,^," ", -e s,' (fetch)',, >&2
269 echo >&2 "$(eval_gettext "If you want to reuse this local git directory instead of cloning again from")"
270 echo >&2 " $realrepo"
271 echo >&2 "$(eval_gettext "use the '--force' option. If the local git directory is not the correct repo")"
272 die "$(eval_gettext "or you are unsure what this means choose another name with the '--name' option.")"
273 else
274 echo "$(eval_gettext "Reactivating local git directory for submodule '\$sm_name'.")"
275 fi
276 fi
277 git submodule--helper clone ${GIT_QUIET:+--quiet} --prefix "$wt_prefix" --path "$sm_path" --name "$sm_name" --url "$realrepo" "$reference" "$depth" || exit
278 (
279 clear_local_git_env
280 cd "$sm_path" &&
281 # ash fails to wordsplit ${branch:+-b "$branch"...}
282 case "$branch" in
283 '') git checkout -f -q ;;
284 ?*) git checkout -f -q -B "$branch" "origin/$branch" ;;
285 esac
286 ) || die "$(eval_gettext "Unable to checkout submodule '\$sm_path'")"
287 fi
288 git config submodule."$sm_name".url "$realrepo"
289
290 git add $force "$sm_path" ||
291 die "$(eval_gettext "Failed to add submodule '\$sm_path'")"
292
293 git config -f .gitmodules submodule."$sm_name".path "$sm_path" &&
294 git config -f .gitmodules submodule."$sm_name".url "$repo" &&
295 if test -n "$branch"
296 then
297 git config -f .gitmodules submodule."$sm_name".branch "$branch"
298 fi &&
299 git add --force .gitmodules ||
300 die "$(eval_gettext "Failed to register submodule '\$sm_path'")"
301}
302
303#
304# Execute an arbitrary command sequence in each checked out
305# submodule
306#
307# $@ = command to execute
308#
309cmd_foreach()
310{
311 # parse $args after "submodule ... foreach".
312 while test $# -ne 0
313 do
314 case "$1" in
315 -q|--quiet)
316 GIT_QUIET=1
317 ;;
318 --recursive)
319 recursive=1
320 ;;
321 -*)
322 usage
323 ;;
324 *)
325 break
326 ;;
327 esac
328 shift
329 done
330
331 toplevel=$(pwd)
332
333 # dup stdin so that it can be restored when running the external
334 # command in the subshell (and a recursive call to this function)
335 exec 3<&0
336
337 git submodule--helper list --prefix "$wt_prefix"|
338 while read mode sha1 stage sm_path
339 do
340 die_if_unmatched "$mode"
341 if test -e "$sm_path"/.git
342 then
343 displaypath=$(relative_path "$prefix$sm_path")
344 say "$(eval_gettext "Entering '\$displaypath'")"
345 name=$(git submodule--helper name "$sm_path")
346 (
347 prefix="$prefix$sm_path/"
348 clear_local_git_env
349 cd "$sm_path" &&
350 sm_path=$(relative_path "$sm_path") &&
351 # we make $path available to scripts ...
352 path=$sm_path &&
353 if test $# -eq 1
354 then
355 eval "$1"
356 else
357 "$@"
358 fi &&
359 if test -n "$recursive"
360 then
361 cmd_foreach "--recursive" "$@"
362 fi
363 ) <&3 3<&- ||
364 die "$(eval_gettext "Stopping at '\$displaypath'; script returned non-zero status.")"
365 fi
366 done
367}
368
369#
370# Register submodules in .git/config
371#
372# $@ = requested paths (default to all)
373#
374cmd_init()
375{
376 # parse $args after "submodule ... init".
377 while test $# -ne 0
378 do
379 case "$1" in
380 -q|--quiet)
381 GIT_QUIET=1
382 ;;
383 --)
384 shift
385 break
386 ;;
387 -*)
388 usage
389 ;;
390 *)
391 break
392 ;;
393 esac
394 shift
395 done
396
397 git submodule--helper list --prefix "$wt_prefix" "$@" |
398 while read mode sha1 stage sm_path
399 do
400 die_if_unmatched "$mode"
401 name=$(git submodule--helper name "$sm_path") || exit
402
403 displaypath=$(relative_path "$prefix$sm_path")
404
405 # Copy url setting when it is not set yet
406 if test -z "$(git config "submodule.$name.url")"
407 then
408 url=$(git config -f .gitmodules submodule."$name".url)
409 test -z "$url" &&
410 die "$(eval_gettext "No url found for submodule path '\$displaypath' in .gitmodules")"
411
412 # Possibly a url relative to parent
413 case "$url" in
414 ./*|../*)
415 url=$(git submodule--helper resolve-relative-url "$url") || exit
416 ;;
417 esac
418 git config submodule."$name".url "$url" ||
419 die "$(eval_gettext "Failed to register url for submodule path '\$displaypath'")"
420
421 say "$(eval_gettext "Submodule '\$name' (\$url) registered for path '\$displaypath'")"
422 fi
423
424 # Copy "update" setting when it is not set yet
425 if upd="$(git config -f .gitmodules submodule."$name".update)" &&
426 test -n "$upd" &&
427 test -z "$(git config submodule."$name".update)"
428 then
429 case "$upd" in
430 checkout | rebase | merge | none)
431 ;; # known modes of updating
432 *)
433 echo >&2 "warning: unknown update mode '$upd' suggested for submodule '$name'"
434 upd=none
435 ;;
436 esac
437 git config submodule."$name".update "$upd" ||
438 die "$(eval_gettext "Failed to register update mode for submodule path '\$displaypath'")"
439 fi
440 done
441}
442
443#
444# Unregister submodules from .git/config and remove their work tree
445#
446# $@ = requested paths (use '.' to deinit all submodules)
447#
448cmd_deinit()
449{
450 # parse $args after "submodule ... deinit".
451 while test $# -ne 0
452 do
453 case "$1" in
454 -f|--force)
455 force=$1
456 ;;
457 -q|--quiet)
458 GIT_QUIET=1
459 ;;
460 --)
461 shift
462 break
463 ;;
464 -*)
465 usage
466 ;;
467 *)
468 break
469 ;;
470 esac
471 shift
472 done
473
474 if test $# = 0
475 then
476 die "$(eval_gettext "Use '.' if you really want to deinitialize all submodules")"
477 fi
478
479 git submodule--helper list --prefix "$wt_prefix" "$@" |
480 while read mode sha1 stage sm_path
481 do
482 die_if_unmatched "$mode"
483 name=$(git submodule--helper name "$sm_path") || exit
484
485 displaypath=$(relative_path "$sm_path")
486
487 # Remove the submodule work tree (unless the user already did it)
488 if test -d "$sm_path"
489 then
490 # Protect submodules containing a .git directory
491 if test -d "$sm_path/.git"
492 then
493 echo >&2 "$(eval_gettext "Submodule work tree '\$displaypath' contains a .git directory")"
494 die "$(eval_gettext "(use 'rm -rf' if you really want to remove it including all of its history)")"
495 fi
496
497 if test -z "$force"
498 then
499 git rm -qn "$sm_path" ||
500 die "$(eval_gettext "Submodule work tree '\$displaypath' contains local modifications; use '-f' to discard them")"
501 fi
502 rm -rf "$sm_path" &&
503 say "$(eval_gettext "Cleared directory '\$displaypath'")" ||
504 say "$(eval_gettext "Could not remove submodule work tree '\$displaypath'")"
505 fi
506
507 mkdir "$sm_path" || say "$(eval_gettext "Could not create empty submodule directory '\$displaypath'")"
508
509 # Remove the .git/config entries (unless the user already did it)
510 if test -n "$(git config --get-regexp submodule."$name\.")"
511 then
512 # Remove the whole section so we have a clean state when
513 # the user later decides to init this submodule again
514 url=$(git config submodule."$name".url)
515 git config --remove-section submodule."$name" 2>/dev/null &&
516 say "$(eval_gettext "Submodule '\$name' (\$url) unregistered for path '\$displaypath'")"
517 fi
518 done
519}
520
521is_tip_reachable () (
522 clear_local_git_env
523 cd "$1" &&
524 rev=$(git rev-list -n 1 "$2" --not --all 2>/dev/null) &&
525 test -z "$rev"
526)
527
528fetch_in_submodule () (
529 clear_local_git_env
530 cd "$1" &&
531 case "$2" in
532 '')
533 git fetch ;;
534 *)
535 git fetch $(get_default_remote) "$2" ;;
536 esac
537)
538
539#
540# Update each submodule path to correct revision, using clone and checkout as needed
541#
542# $@ = requested paths (default to all)
543#
544cmd_update()
545{
546 # parse $args after "submodule ... update".
547 while test $# -ne 0
548 do
549 case "$1" in
550 -q|--quiet)
551 GIT_QUIET=1
552 ;;
553 -i|--init)
554 init=1
555 ;;
556 --remote)
557 remote=1
558 ;;
559 -N|--no-fetch)
560 nofetch=1
561 ;;
562 -f|--force)
563 force=$1
564 ;;
565 -r|--rebase)
566 update="rebase"
567 ;;
568 --reference)
569 case "$2" in '') usage ;; esac
570 reference="--reference=$2"
571 shift
572 ;;
573 --reference=*)
574 reference="$1"
575 ;;
576 -m|--merge)
577 update="merge"
578 ;;
579 --recursive)
580 recursive=1
581 ;;
582 --checkout)
583 update="checkout"
584 ;;
585 --depth)
586 case "$2" in '') usage ;; esac
587 depth="--depth=$2"
588 shift
589 ;;
590 --depth=*)
591 depth=$1
592 ;;
593 -j|--jobs)
594 case "$2" in '') usage ;; esac
595 jobs="--jobs=$2"
596 shift
597 ;;
598 --jobs=*)
599 jobs=$1
600 ;;
601 --)
602 shift
603 break
604 ;;
605 -*)
606 usage
607 ;;
608 *)
609 break
610 ;;
611 esac
612 shift
613 done
614
615 if test -n "$init"
616 then
617 cmd_init "--" "$@" || return
618 fi
619
620 {
621 git submodule--helper update-clone ${GIT_QUIET:+--quiet} \
622 ${wt_prefix:+--prefix "$wt_prefix"} \
623 ${prefix:+--recursive-prefix "$prefix"} \
624 ${update:+--update "$update"} \
625 ${reference:+--reference "$reference"} \
626 ${depth:+--depth "$depth"} \
627 ${jobs:+$jobs} \
628 "$@" || echo "#unmatched"
629 } | {
630 err=
631 while read mode sha1 stage just_cloned sm_path
632 do
633 die_if_unmatched "$mode"
634
635 name=$(git submodule--helper name "$sm_path") || exit
636 url=$(git config submodule."$name".url)
637 branch=$(get_submodule_config "$name" branch master)
638 if ! test -z "$update"
639 then
640 update_module=$update
641 else
642 update_module=$(git config submodule."$name".update)
643 if test -z "$update_module"
644 then
645 update_module="checkout"
646 fi
647 fi
648
649 displaypath=$(relative_path "$prefix$sm_path")
650
651 if test $just_cloned -eq 1
652 then
653 subsha1=
654 update_module=checkout
655 else
656 subsha1=$(clear_local_git_env; cd "$sm_path" &&
657 git rev-parse --verify HEAD) ||
658 die "$(eval_gettext "Unable to find current revision in submodule path '\$displaypath'")"
659 fi
660
661 if test -n "$remote"
662 then
663 if test -z "$nofetch"
664 then
665 # Fetch remote before determining tracking $sha1
666 (clear_local_git_env; cd "$sm_path" && git-fetch) ||
667 die "$(eval_gettext "Unable to fetch in submodule path '\$sm_path'")"
668 fi
669 remote_name=$(clear_local_git_env; cd "$sm_path" && get_default_remote)
670 sha1=$(clear_local_git_env; cd "$sm_path" &&
671 git rev-parse --verify "${remote_name}/${branch}") ||
672 die "$(eval_gettext "Unable to find current ${remote_name}/${branch} revision in submodule path '\$sm_path'")"
673 fi
674
675 if test "$subsha1" != "$sha1" || test -n "$force"
676 then
677 subforce=$force
678 # If we don't already have a -f flag and the submodule has never been checked out
679 if test -z "$subsha1" && test -z "$force"
680 then
681 subforce="-f"
682 fi
683
684 if test -z "$nofetch"
685 then
686 # Run fetch only if $sha1 isn't present or it
687 # is not reachable from a ref.
688 is_tip_reachable "$sm_path" "$sha1" ||
689 fetch_in_submodule "$sm_path" ||
690 die "$(eval_gettext "Unable to fetch in submodule path '\$displaypath'")"
691
692 # Now we tried the usual fetch, but $sha1 may
693 # not be reachable from any of the refs
694 is_tip_reachable "$sm_path" "$sha1" ||
695 fetch_in_submodule "$sm_path" "$sha1" ||
696 die "$(eval_gettext "Fetched in submodule path '\$displaypath', but it did not contain $sha1. Direct fetching of that commit failed.")"
697 fi
698
699 must_die_on_failure=
700 case "$update_module" in
701 checkout)
702 command="git checkout $subforce -q"
703 die_msg="$(eval_gettext "Unable to checkout '\$sha1' in submodule path '\$displaypath'")"
704 say_msg="$(eval_gettext "Submodule path '\$displaypath': checked out '\$sha1'")"
705 ;;
706 rebase)
707 command="git rebase"
708 die_msg="$(eval_gettext "Unable to rebase '\$sha1' in submodule path '\$displaypath'")"
709 say_msg="$(eval_gettext "Submodule path '\$displaypath': rebased into '\$sha1'")"
710 must_die_on_failure=yes
711 ;;
712 merge)
713 command="git merge"
714 die_msg="$(eval_gettext "Unable to merge '\$sha1' in submodule path '\$displaypath'")"
715 say_msg="$(eval_gettext "Submodule path '\$displaypath': merged in '\$sha1'")"
716 must_die_on_failure=yes
717 ;;
718 !*)
719 command="${update_module#!}"
720 die_msg="$(eval_gettext "Execution of '\$command \$sha1' failed in submodule path '\$displaypath'")"
721 say_msg="$(eval_gettext "Submodule path '\$displaypath': '\$command \$sha1'")"
722 must_die_on_failure=yes
723 ;;
724 *)
725 die "$(eval_gettext "Invalid update mode '$update_module' for submodule '$name'")"
726 esac
727
728 if (clear_local_git_env; cd "$sm_path" && $command "$sha1")
729 then
730 say "$say_msg"
731 elif test -n "$must_die_on_failure"
732 then
733 die_with_status 2 "$die_msg"
734 else
735 err="${err};$die_msg"
736 continue
737 fi
738 fi
739
740 if test -n "$recursive"
741 then
742 (
743 prefix="$prefix$sm_path/"
744 clear_local_git_env
745 cd "$sm_path" &&
746 eval cmd_update
747 )
748 res=$?
749 if test $res -gt 0
750 then
751 die_msg="$(eval_gettext "Failed to recurse into submodule path '\$displaypath'")"
752 if test $res -eq 1
753 then
754 err="${err};$die_msg"
755 continue
756 else
757 die_with_status $res "$die_msg"
758 fi
759 fi
760 fi
761 done
762
763 if test -n "$err"
764 then
765 OIFS=$IFS
766 IFS=';'
767 for e in $err
768 do
769 if test -n "$e"
770 then
771 echo >&2 "$e"
772 fi
773 done
774 IFS=$OIFS
775 exit 1
776 fi
777 }
778}
779
780set_name_rev () {
781 revname=$( (
782 clear_local_git_env
783 cd "$1" && {
784 git describe "$2" 2>/dev/null ||
785 git describe --tags "$2" 2>/dev/null ||
786 git describe --contains "$2" 2>/dev/null ||
787 git describe --all --always "$2"
788 }
789 ) )
790 test -z "$revname" || revname=" ($revname)"
791}
792#
793# Show commit summary for submodules in index or working tree
794#
795# If '--cached' is given, show summary between index and given commit,
796# or between working tree and given commit
797#
798# $@ = [commit (default 'HEAD'),] requested paths (default all)
799#
800cmd_summary() {
801 summary_limit=-1
802 for_status=
803 diff_cmd=diff-index
804
805 # parse $args after "submodule ... summary".
806 while test $# -ne 0
807 do
808 case "$1" in
809 --cached)
810 cached="$1"
811 ;;
812 --files)
813 files="$1"
814 ;;
815 --for-status)
816 for_status="$1"
817 ;;
818 -n|--summary-limit)
819 summary_limit="$2"
820 isnumber "$summary_limit" || usage
821 shift
822 ;;
823 --summary-limit=*)
824 summary_limit="${1#--summary-limit=}"
825 isnumber "$summary_limit" || usage
826 ;;
827 --)
828 shift
829 break
830 ;;
831 -*)
832 usage
833 ;;
834 *)
835 break
836 ;;
837 esac
838 shift
839 done
840
841 test $summary_limit = 0 && return
842
843 if rev=$(git rev-parse -q --verify --default HEAD ${1+"$1"})
844 then
845 head=$rev
846 test $# = 0 || shift
847 elif test -z "$1" || test "$1" = "HEAD"
848 then
849 # before the first commit: compare with an empty tree
850 head=$(git hash-object -w -t tree --stdin </dev/null)
851 test -z "$1" || shift
852 else
853 head="HEAD"
854 fi
855
856 if [ -n "$files" ]
857 then
858 test -n "$cached" &&
859 die "$(gettext "The --cached option cannot be used with the --files option")"
860 diff_cmd=diff-files
861 head=
862 fi
863
864 cd_to_toplevel
865 eval "set $(git rev-parse --sq --prefix "$wt_prefix" -- "$@")"
866 # Get modified modules cared by user
867 modules=$(git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- "$@" |
868 sane_egrep '^:([0-7]* )?160000' |
869 while read mod_src mod_dst sha1_src sha1_dst status sm_path
870 do
871 # Always show modules deleted or type-changed (blob<->module)
872 if test "$status" = D || test "$status" = T
873 then
874 printf '%s\n' "$sm_path"
875 continue
876 fi
877 # Respect the ignore setting for --for-status.
878 if test -n "$for_status"
879 then
880 name=$(git submodule--helper name "$sm_path")
881 ignore_config=$(get_submodule_config "$name" ignore none)
882 test $status != A && test $ignore_config = all && continue
883 fi
884 # Also show added or modified modules which are checked out
885 GIT_DIR="$sm_path/.git" git-rev-parse --git-dir >/dev/null 2>&1 &&
886 printf '%s\n' "$sm_path"
887 done
888 )
889
890 test -z "$modules" && return
891
892 git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- $modules |
893 sane_egrep '^:([0-7]* )?160000' |
894 cut -c2- |
895 while read mod_src mod_dst sha1_src sha1_dst status name
896 do
897 if test -z "$cached" &&
898 test $sha1_dst = 0000000000000000000000000000000000000000
899 then
900 case "$mod_dst" in
901 160000)
902 sha1_dst=$(GIT_DIR="$name/.git" git rev-parse HEAD)
903 ;;
904 100644 | 100755 | 120000)
905 sha1_dst=$(git hash-object $name)
906 ;;
907 000000)
908 ;; # removed
909 *)
910 # unexpected type
911 eval_gettextln "unexpected mode \$mod_dst" >&2
912 continue ;;
913 esac
914 fi
915 missing_src=
916 missing_dst=
917
918 test $mod_src = 160000 &&
919 ! GIT_DIR="$name/.git" git-rev-parse -q --verify $sha1_src^0 >/dev/null &&
920 missing_src=t
921
922 test $mod_dst = 160000 &&
923 ! GIT_DIR="$name/.git" git-rev-parse -q --verify $sha1_dst^0 >/dev/null &&
924 missing_dst=t
925
926 display_name=$(relative_path "$name")
927
928 total_commits=
929 case "$missing_src,$missing_dst" in
930 t,)
931 errmsg="$(eval_gettext " Warn: \$display_name doesn't contain commit \$sha1_src")"
932 ;;
933 ,t)
934 errmsg="$(eval_gettext " Warn: \$display_name doesn't contain commit \$sha1_dst")"
935 ;;
936 t,t)
937 errmsg="$(eval_gettext " Warn: \$display_name doesn't contain commits \$sha1_src and \$sha1_dst")"
938 ;;
939 *)
940 errmsg=
941 total_commits=$(
942 if test $mod_src = 160000 && test $mod_dst = 160000
943 then
944 range="$sha1_src...$sha1_dst"
945 elif test $mod_src = 160000
946 then
947 range=$sha1_src
948 else
949 range=$sha1_dst
950 fi
951 GIT_DIR="$name/.git" \
952 git rev-list --first-parent $range -- | wc -l
953 )
954 total_commits=" ($(($total_commits + 0)))"
955 ;;
956 esac
957
958 sha1_abbr_src=$(echo $sha1_src | cut -c1-7)
959 sha1_abbr_dst=$(echo $sha1_dst | cut -c1-7)
960 if test $status = T
961 then
962 blob="$(gettext "blob")"
963 submodule="$(gettext "submodule")"
964 if test $mod_dst = 160000
965 then
966 echo "* $display_name $sha1_abbr_src($blob)->$sha1_abbr_dst($submodule)$total_commits:"
967 else
968 echo "* $display_name $sha1_abbr_src($submodule)->$sha1_abbr_dst($blob)$total_commits:"
969 fi
970 else
971 echo "* $display_name $sha1_abbr_src...$sha1_abbr_dst$total_commits:"
972 fi
973 if test -n "$errmsg"
974 then
975 # Don't give error msg for modification whose dst is not submodule
976 # i.e. deleted or changed to blob
977 test $mod_dst = 160000 && echo "$errmsg"
978 else
979 if test $mod_src = 160000 && test $mod_dst = 160000
980 then
981 limit=
982 test $summary_limit -gt 0 && limit="-$summary_limit"
983 GIT_DIR="$name/.git" \
984 git log $limit --pretty='format: %m %s' \
985 --first-parent $sha1_src...$sha1_dst
986 elif test $mod_dst = 160000
987 then
988 GIT_DIR="$name/.git" \
989 git log --pretty='format: > %s' -1 $sha1_dst
990 else
991 GIT_DIR="$name/.git" \
992 git log --pretty='format: < %s' -1 $sha1_src
993 fi
994 echo
995 fi
996 echo
997 done
998}
999#
1000# List all submodules, prefixed with:
1001# - submodule not initialized
1002# + different revision checked out
1003#
1004# If --cached was specified the revision in the index will be printed
1005# instead of the currently checked out revision.
1006#
1007# $@ = requested paths (default to all)
1008#
1009cmd_status()
1010{
1011 # parse $args after "submodule ... status".
1012 while test $# -ne 0
1013 do
1014 case "$1" in
1015 -q|--quiet)
1016 GIT_QUIET=1
1017 ;;
1018 --cached)
1019 cached=1
1020 ;;
1021 --recursive)
1022 recursive=1
1023 ;;
1024 --)
1025 shift
1026 break
1027 ;;
1028 -*)
1029 usage
1030 ;;
1031 *)
1032 break
1033 ;;
1034 esac
1035 shift
1036 done
1037
1038 git submodule--helper list --prefix "$wt_prefix" "$@" |
1039 while read mode sha1 stage sm_path
1040 do
1041 die_if_unmatched "$mode"
1042 name=$(git submodule--helper name "$sm_path") || exit
1043 url=$(git config submodule."$name".url)
1044 displaypath=$(relative_path "$prefix$sm_path")
1045 if test "$stage" = U
1046 then
1047 say "U$sha1 $displaypath"
1048 continue
1049 fi
1050 if test -z "$url" ||
1051 {
1052 ! test -d "$sm_path"/.git &&
1053 ! test -f "$sm_path"/.git
1054 }
1055 then
1056 say "-$sha1 $displaypath"
1057 continue;
1058 fi
1059 if git diff-files --ignore-submodules=dirty --quiet -- "$sm_path"
1060 then
1061 set_name_rev "$sm_path" "$sha1"
1062 say " $sha1 $displaypath$revname"
1063 else
1064 if test -z "$cached"
1065 then
1066 sha1=$(clear_local_git_env; cd "$sm_path" && git rev-parse --verify HEAD)
1067 fi
1068 set_name_rev "$sm_path" "$sha1"
1069 say "+$sha1 $displaypath$revname"
1070 fi
1071
1072 if test -n "$recursive"
1073 then
1074 (
1075 prefix="$displaypath/"
1076 clear_local_git_env
1077 wt_prefix=
1078 cd "$sm_path" &&
1079 eval cmd_status
1080 ) ||
1081 die "$(eval_gettext "Failed to recurse into submodule path '\$sm_path'")"
1082 fi
1083 done
1084}
1085#
1086# Sync remote urls for submodules
1087# This makes the value for remote.$remote.url match the value
1088# specified in .gitmodules.
1089#
1090cmd_sync()
1091{
1092 while test $# -ne 0
1093 do
1094 case "$1" in
1095 -q|--quiet)
1096 GIT_QUIET=1
1097 shift
1098 ;;
1099 --recursive)
1100 recursive=1
1101 shift
1102 ;;
1103 --)
1104 shift
1105 break
1106 ;;
1107 -*)
1108 usage
1109 ;;
1110 *)
1111 break
1112 ;;
1113 esac
1114 done
1115 cd_to_toplevel
1116 git submodule--helper list --prefix "$wt_prefix" "$@" |
1117 while read mode sha1 stage sm_path
1118 do
1119 die_if_unmatched "$mode"
1120 name=$(git submodule--helper name "$sm_path")
1121 url=$(git config -f .gitmodules --get submodule."$name".url)
1122
1123 # Possibly a url relative to parent
1124 case "$url" in
1125 ./*|../*)
1126 # rewrite foo/bar as ../.. to find path from
1127 # submodule work tree to superproject work tree
1128 up_path="$(printf '%s\n' "$sm_path" | sed "s/[^/][^/]*/../g")" &&
1129 # guarantee a trailing /
1130 up_path=${up_path%/}/ &&
1131 # path from submodule work tree to submodule origin repo
1132 sub_origin_url=$(git submodule--helper resolve-relative-url "$url" "$up_path") &&
1133 # path from superproject work tree to submodule origin repo
1134 super_config_url=$(git submodule--helper resolve-relative-url "$url") || exit
1135 ;;
1136 *)
1137 sub_origin_url="$url"
1138 super_config_url="$url"
1139 ;;
1140 esac
1141
1142 if git config "submodule.$name.url" >/dev/null 2>/dev/null
1143 then
1144 displaypath=$(relative_path "$prefix$sm_path")
1145 say "$(eval_gettext "Synchronizing submodule url for '\$displaypath'")"
1146 git config submodule."$name".url "$super_config_url"
1147
1148 if test -e "$sm_path"/.git
1149 then
1150 (
1151 clear_local_git_env
1152 cd "$sm_path"
1153 remote=$(get_default_remote)
1154 git config remote."$remote".url "$sub_origin_url"
1155
1156 if test -n "$recursive"
1157 then
1158 prefix="$prefix$sm_path/"
1159 eval cmd_sync
1160 fi
1161 )
1162 fi
1163 fi
1164 done
1165}
1166
1167# This loop parses the command line arguments to find the
1168# subcommand name to dispatch. Parsing of the subcommand specific
1169# options are primarily done by the subcommand implementations.
1170# Subcommand specific options such as --branch and --cached are
1171# parsed here as well, for backward compatibility.
1172
1173while test $# != 0 && test -z "$command"
1174do
1175 case "$1" in
1176 add | foreach | init | deinit | update | status | summary | sync)
1177 command=$1
1178 ;;
1179 -q|--quiet)
1180 GIT_QUIET=1
1181 ;;
1182 -b|--branch)
1183 case "$2" in
1184 '')
1185 usage
1186 ;;
1187 esac
1188 branch="$2"; shift
1189 ;;
1190 --cached)
1191 cached="$1"
1192 ;;
1193 --)
1194 break
1195 ;;
1196 -*)
1197 usage
1198 ;;
1199 *)
1200 break
1201 ;;
1202 esac
1203 shift
1204done
1205
1206# No command word defaults to "status"
1207if test -z "$command"
1208then
1209 if test $# = 0
1210 then
1211 command=status
1212 else
1213 usage
1214 fi
1215fi
1216
1217# "-b branch" is accepted only by "add"
1218if test -n "$branch" && test "$command" != add
1219then
1220 usage
1221fi
1222
1223# "--cached" is accepted only by "status" and "summary"
1224if test -n "$cached" && test "$command" != status && test "$command" != summary
1225then
1226 usage
1227fi
1228
1229"cmd_$command" "$@"